<?php

//Note that since we are using classes, the prefix use is not useful anymore. Nonetheless, watchout html id tags
//Also I didn't find a practical way to instance the class and include the page in the process.
//So, I decided to make a static class to make it work
//Updated: after reconverting the class to static and reformating array(&$this,'method') to settingsAPI::method, it SEEMS is working!!!
/*
in the database will be stored something like statcomm_options:
a:6:{s:10:"chk_logged";s:2:"on";s:14:"chk_no_spiders";N;s:19:"cmb_delete_visitors";s:8:"3 months";s:18:"cmb_delete_spiders";
s:6:"1 Week";s:18:"cmb_overview_graph";s:2:"30";s:14:"cmb_capability";s:20:"edit_published_posts";}
So, the correct way to get the data is:
$options= get_option("statcomm_options");
echo "logged:" . (($options["chk_logged"]=='on')?'on':'off') . "<br/>"; //ONE WAY
echo "spiders:" . (($options["chk_no_spiders"]=='on')?'1':'0') . "<br/>"; //ANOTHER WAY, maybe better
echo "cmb_delete_visitors:" . $options["cmb_delete_visitors"] . "<br/>";
echo "cmb_delete_spiders:" . $options["cmb_delete_spiders"] . "<br/>";
echo "cmb_overview_graph:" . $options["cmb_overview_graph"] . "<br/>";
echo "cmb_capability:" . $options["cmb_capability"] . "<br/>";

Note also we don't need to put a prefix on options: we have an array properly prefixed, the inner valuer do not need to be prefixed.

To improve: the combo cannot easily be translated, since I'storing the select value and not the inner one. this has to be corrected
on the combos.
To improve: current user can't set a capability above it own level.

*/

class settingsAPI
{
    //Basic idea: don't mess with options names, they are already defined.
    static function getOptions()
    {
        return get_option("statcomm_options");
    }

	// Draw the option page
	static function statcomm_option_page() {
        //to select icon for screen_icon, see wp-admin/css/colors-classic.dev.css and icon-xxxx definition
        //used in wp-admin/includes/template.php Example: screen_icon('options-general');
		?>
		<div class="wrap">

			<div id="icon-statcomm" class="icon32"><br/></div>
			<form action="options.php" method="post">
				<?php settings_fields('statcomm_options'); ?>
				<?php do_settings_sections('statcomm_setting_page'); ?><br/>
			<input class="button-primary" name="Submit" type="submit" value="<?php _e('Save Settings','statcomm'); ?>" />
			</form>
		</div>
		<?php
	}

	static function statcomm_admin_init(){
		//register_setting(group_name,option_name,callback)
		register_setting('statcomm_options','statcomm_options','settingsAPI::statcomm_validate_options');

		//add_settings_section(html_id_tag,title,callback,settings page)
		add_settings_section('statcomm_main',__('<h2>StatComm Settings Options</h2>','statcomm'),
                             'settingsAPI::statcomm_section_text','statcomm_setting_page');

		//add_settings_field(html_id_tag,text,callback,page,id_section)
		add_settings_field('statcomm_chk_log',__('Also collect data about logged users','statcomm'),
                            'settingsAPI::statcomm_setting_chk_log',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_chk_no_spiders',__('Do not collect spiders visits','statcomm'),
                            'settingsAPI::statcomm_setting_chk_no_spiders',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_delete_visitors',__('Automatically delete visits older than','statcomm'),
                            'settingsAPI::statcomm_setting_delete_visitors',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_delete_spiders',__('Automatically delete spiders older than','statcomm'),
                            'settingsAPI::statcomm_setting_delete_spiders',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_overview_graph',__('Days in Overview graph','statcomm'),
                            'settingsAPI::statcomm_overview_graph',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_capability',__('Min. allowed access','statcomm'),
                            'settingsAPI::statcomm_capability',	'statcomm_setting_page','statcomm_main');

        /*
        add_settings_field('statcomm_refresh',__('User-Agent-String DB download refresh period','statcomm'),
                            'settingsAPI::statcomm_uarefresh',	'statcomm_setting_page','statcomm_main');
        */

        add_settings_field('statcomm_chk_uas',__('User Agent String Database','statcomm'),
                            'settingsAPI::statcomm_setting_chk_uas',	'statcomm_setting_page','statcomm_main');

        add_settings_field('statcomm_chk_gcl',__('Check to enable Maxmind Geolocation service','statcomm'),
                            'settingsAPI::statcomm_setting_chk_glc',	'statcomm_setting_page','statcomm_main');

        add_settings_field('statcomm_spy_days',__('How many days to spy back','statcomm'),
                            'settingsAPI::statcomm_setting_spy_back',
            'statcomm_setting_page','statcomm_main');

        add_settings_field('statcomm_spy_results',__('How many result in the spy list','statcomm'),
                            'settingsAPI::statcomm_setting_spy_results', 'statcomm_setting_page','statcomm_main');

	}

	// Draw the section header
    //v1.6.5: Check panel
    //v1.6.80: Updated for manual
	static function statcomm_section_text() {
		//echo '<p>' . __('Current settings for StatComm','statcomm') . '</p>';
        $green = "<div style='color:GREEN;'>OK</div>";
        $red   = "<div style='color:RED;'>ERROR</div>";
        $enabled ="<div style='color:GREEN;'>ENABLED</div>";
        $disabled="<div style='color:GRAY;'>DISABLED</div>";

        print "<div class='wrap'>";
        print "<table class='widefat'><thead><tr>";
        print "<th scope='col'>" . __('Component Checking', 'statcomm') . "</th>";
        print "<th scope='col'>" . __('Status', 'statcomm') . "</th>";
        print "</tr></thead>";
        print "</div>";


        //ZipArchive checking
        $flagZip = class_exists('ZipArchive')?$green:$red;

        //Folder writable
        $cache_dir= plugin_dir_path(dirname(__FILE__)) . 'def';
        $PARSER_CACHE = $cache_dir . '/cache.ini';
        $cacheIni = @parse_ini_file($PARSER_CACHE);
        $lastupdate = isset($cacheIni['lastupdate'])?$cacheIni['lastupdate']:0;
        $localversion= isset($cacheIni['localversion'])?$cacheIni['localversion']:0;

        $options=get_option("statcomm_options");

        utilities::fl("time:", time());

        $flagCache = is_writable($cache_dir)?$green:$red;

        print "<tbody id='the-list'>";
        print "<tr><td>" . __('Checking if ZipArchive class is available (used for unpackage database)','statcomm') . "</td>";
        print "<td>" . $flagZip . "</td></tr>";

        print "<tr><td>" . __('Checking if folder def is writable (used for save UAS database)','statcomm') . "</td>";
        print "<td>" . $flagCache . "</td></tr>";


        print "<tr><td>" . __('Current User Agent String DB version','statcomm') . "</td>";
        if ($lastupdate==0)
        {
            print "<td><b>" . $red . __("Cache.ini not found or not readable","statcomm") . "</td></tr>";
        }
        else
        {
            print "<td><b>" . $localversion . "</b> dowloaded in date " . gmdate("Y-m-d h:i:s",$lastupdate) .   "</td></tr>";
        }

 		print "</tr>\n";
       	print "</table></div>";

	}

	/*
	// Display and fill the form field
	// It's worth mentioning that ID settings in the add_settings_field DOES NOT HAVE TO MATCH ID input field HTML Tag
	// in this callback function. Just remember avoid conflicting names
	function statcomm_setting_input() {
		// get option 'text_string' value from the database
		$options = get_option( 'statcomm_options' );
		$text_string = $options['text_string'];
		// echo the field
		echo "<input id='text_string' name='statcomm_options[text_string]' type='text' value='$text_string' />";
	}
	*/
	static function statcomm_setting_chk_log() {
		// get option 'text_string' value from the database
		$options = get_option( 'statcomm_options' );
		$chk =isset($options['chk_logged'])?$options['chk_logged']:'';
		$checked='';
		if($chk) { $checked = ' checked="checked" '; }
		echo "<input id='chk_logged' name='statcomm_options[chk_logged]' type='checkbox' $checked />";
	}

	static function statcomm_setting_chk_no_spiders() {
		// get option 'text_string' value from the database
		$options = get_option( 'statcomm_options' );
		$chk = isset($options['chk_no_spiders'])?$options['chk_no_spiders']:'';
		$checked='';
		if($chk) { $checked = ' checked="checked" '; }
		echo "<input id='chk_no_spiders' name='statcomm_options[chk_no_spiders]' type='checkbox' $checked />";

	}

	static function statcomm_setting_delete_visitors() {
		$options = get_option( 'statcomm_options' );
		$items = array("Never delete!", "1 month", "3 months", "6 months", "1 year");
		echo "<select id='cmb_delete_visitors' name='statcomm_options[cmb_delete_visitors]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_delete_visitors']==$item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";
	}

	static function statcomm_setting_delete_spiders() {
		$options = get_option( 'statcomm_options' );
		$items = array("Never delete!", "1 Day", "1 Week", "1 Month", "1 Year");
		echo "<select id='cmb_delete_spiders' name='statcomm_options[cmb_delete_spiders]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_delete_spiders']==$item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";
	}

	static function statcomm_overview_graph() {
		$options = get_option( 'statcomm_options' );
		$items = array("7", "10", "20", "30", "50");
		echo "<select id='cmb_overview_graph' name='statcomm_options[cmb_overview_graph]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_overview_graph']==$item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";
	}

	//Improved: no more indescifrable minimum capability. Note that plugin is not yet multisite.
	static function statcomm_capability() {
		$options = get_option( 'statcomm_options' );
		$items = array( array ("Super Admin","manage_network")
					,   array ("Administrator", "activate_plugins")
				    ,   array ("Editor", "moderate_comments")
					,   array ("Author", "edit_published_posts")
					,   array ("Contributor", "edit_posts")
					,   array ("Suscriber","read") );

		echo "<select id='cmb_capability' name='statcomm_options[cmb_capability]'>";
		foreach($items as $item) {
            //v1.6.5:capability control
            if (current_user_can($item[1])) //Only show what you can
            {
			$selected = ($options['cmb_capability']==$item[1]) ? 'selected="selected"' : '';
			echo "<option value='{$item[1]}' $selected>{$item[0]}</option>";
            }
		}
		echo "</select>";
		echo "<div> " . _e("Need help about roles?","statcomm") . "<a target='_blank' href='http://codex.wordpress.org/Roles_and_Capabilities#Summary_of_Roles'>Go to Wordpress Codex Help: Roles & Capabilities</a></div>";
	}

/**
 * v1.6.80 Changed to manual procedure. Much more manageable than previously
 * @static
 *
 */
    static function statcomm_setting_chk_uas() {

        if (utilities::uaparserEnabled()){
            $isUpdated=utilities::UASIsUpdated(); //return array(boolean,string);
            $status= isset($isUpdated['status'])?$isUpdated['status']:true;
            $msg   = isset($isUpdated['msg'])?$isUpdated['msg']:"";
            if (!$isUpdated['status'])
            {
                //Check the msg, if the msg <>'' then there is an error
                if (!empty($msg))
                {
                    echo __('There was an error when checking if updated:', $msg);
                }
                else
                {
                echo                '<a href="' . wp_nonce_url(admin_url( 'admin.php?page=statComm/uasupdate' ),'statcomm'). '" >' .
                    __('A new version of UAS database is available. Click here to start', 'statcomm'). '</a></span>';
                }
            }
            else
            {
                echo "<span style='color:GREEN;'>" .__('  UAS database installed and ready to go. ','statcomm') ;
            }
        }
        else
        {
            echo "<span style='color:RED;'>" . __('  You need to install UAS database to get started.', 'statcomm') .
                '<a href="' . wp_nonce_url(admin_url( 'admin.php?page=statComm/uasupdate' ),'statcomm'). '" >' .
                __('Click to proceed (it will start automatically)', 'statcomm'). '</a></span>';
        }
    }

//statcomm_setting_chk_glc
    static function statcomm_setting_chk_glc() {
        // get option 'text_string' value from the database
        $options = get_option( 'statcomm_options' );
        $chk =isset($options['chk_glc'])?$options['chk_glc']:'';
        $checked='';
        $glc=file_exists(plugin_dir_path(dirname(__FILE__)) . 'def/GeoLiteCity.dat');
        //Prerrogative: if file does not exist, check can't be enabled and also is grayed
        $isdisabled='';
        if (!$glc)
        {
            $chk=false;
            $isdisabled='DISABLED';
        }
        if($chk) { $checked = ' checked="checked" '; }
        echo "<input id='chk_glc' name='statcomm_options[chk_glc]' type='checkbox' $checked $isdisabled/>";
        //Let's check if the database is already installed.

        if ($glc){
            echo "<span style='color:GREEN;'>" .__('  Maxmind database installed and ready to go. ','statcomm') .
                 '<a href="' . wp_nonce_url(admin_url( 'admin.php?page=statComm/glcupdate' ),'statcomm'). '" >'.
                 __('Check if you need to update (it will start automatically)', 'statcomm'). '</a></span>';
        }
        else
        {
            echo "<span style='color:RED;'>" . __('  You need to install Maxmind database to get started.', 'statcomm') .
            '<a href="' . wp_nonce_url(admin_url( 'admin.php?page=statComm/glcupdate' ),'statcomm'). '" >'.
            __('Click to proceed (it will start automatically)', 'statcomm'). '</a></span>';

        }

    }

    /**
     * Decide how many days back the spy tool has to search
     * @static
     */
    static function statcomm_setting_spy_back()
    {
        $options = get_option( 'statcomm_options' );
        $items = array (array (__("2 days (default)","statcomm"), "2" )
        ,       array (__("1 week","statcomm"), "7")
        ,       array (__("1 month","statcomm"),"31")
        ,       array (__("1 year (are you sure?)","statcomm"), "365")
        );

        echo "<select id='cmb_spy_back' name='statcomm_options[cmb_spy_back]'>";
        foreach($items as $item) {
            $uar=isset($options['cmb_spy_back'])?$options['cmb_spy_back']:"";
            $selected = ($uar==$item[1]) ? 'selected="selected"' : '';
            echo "<option value='$item[1]' $selected>{$item[0]}</option>";
        }
        echo "</select>";
        echo __(" Spy Tool:This setting defines how many days go back in the past looking for activity user.","statcomm");
    }

    static function statcomm_setting_spy_results()
    {
        $options = get_option( 'statcomm_options' );
        $items = array (array (__("5 results (default)","statcomm"), "5" )
        ,       array (__("10 results","statcomm"), "10")
        ,       array (__("15 results","statcomm"),"15")
        ,       array (__("20 results","statcomm"),"20")
        );

        echo "<select id='cmb_spy_results' name='statcomm_options[cmb_spy_results]'>";
        foreach($items as $item) {
            $uar=isset($options['cmb_spy_results'])?$options['cmb_spy_results']:"";
            $selected = ($uar==$item[1]) ? 'selected="selected"' : '';
            echo "<option value='$item[1]' $selected>{$item[0]}</option>";
        }
        echo "</select>";
        echo __(" Spy Tool:How many activity results when looking back for a user.","statcomm");
    }

	// Validate user input (we want text only)
	// IMPORTANT: this function gets an array in ($input) and array out $valid. EVERY FIELD has to be copied
	// from on array to another previous validation. If not, data of fields won't be saved.
	static function statcomm_validate_options( $input ) {
		/*
		$valid['text_string'] = preg_replace( '/[^a-zA-Z]/', '', $input['text_string'] );

		if( $valid['text_string'] != $input['text_string'] ) {
		//add_settings_error(title_setting,html_id_tag,error_msg,error/update
			add_settings_error('statcomm_text_string','statcomm_texterror','Incorrect value entered!','error');
		}
		*/
		//$valid= array('chk_logged','chk_no_spiders','cmb_delete_visitors','cmb_delete_spiders',
		//'cmb_overview_graph','cmb_capability');
		$valid['chk_logged']          = isset($input['chk_logged'])?$input['chk_logged']:"";
		$valid['chk_no_spiders']      = isset($input['chk_no_spiders'])?$input['chk_no_spiders']:"";
		$valid['cmb_delete_visitors'] = isset($input['cmb_delete_visitors'])?$input['cmb_delete_visitors']:"";
		$valid['cmb_delete_spiders']  = isset($input['cmb_delete_spiders'])?$input['cmb_delete_spiders']:"";
		$valid['cmb_overview_graph']  = isset($input['cmb_overview_graph'])?$input['cmb_overview_graph']:"";
		$valid['cmb_capability']      = isset($input['cmb_capability'])?$input['cmb_capability']:"";
        $valid['chk_glc']             = isset($input['chk_glc'])?$input['chk_glc']:"";
        $valid['cmb_spy_back']        = isset($input['cmb_spy_back'])?$input['cmb_spy_back']:"";
        $valid['cmb_spy_results']     = isset($input['cmb_spy_results'])?$input['cmb_spy_results']:"";

		return $valid;
	}

    /**
     * Defines default values when initializing the plugin
     * @static
     * v1.7.00: updated to include version control. Used for upgrades.
     * Updated: new statcomm_plugin_version independent of statcomm options
     */
    static function defaultValues()
    {
        //Default values. Values not present usually are chk_xxx values (boolean) default to false.
        $options= array(
              'chk_logged' => false
        ,     'chk_no_spiders' => false
        ,     'cmb_delete_visitors' => 'Never delete!'
        ,     'cmb_delete_spiders' => 'Never delete!'
        ,     'cmb_overview_graph' => '10'
        ,     'cmb_capability' => 'activate_plugins'
        ,     'chk_glc'        => false
        ,     'cmb_spy_back'   =>'2'
        ,     'cmb_spy_results'=>'5'
        );
        update_option('statcomm_options', $options);
        update_option('statcomm_plugin_version' , utilities::PLUGIN_VERSION);
        $migration_options= array(
            'chk_delspiders' => ''
        ,   'cutting_date'   => ''
        );
        update_option('statcomm_migration_options', $migration_options);
    }

}